package com.ruoyi.framework.web.service;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.ruoyi.common.core.domain.entity.SysDept;
import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.core.domain.model.LoginUser;
import com.ruoyi.common.enums.UserStatus;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.system.domain.SysTenant;
import com.ruoyi.system.service.ISysDeptService;
import com.ruoyi.system.service.ISysUserService;
import com.ruoyi.system.service.impl.SysTenantServiceImpl;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;

/**
 * 用户验证处理
 *
 * @author ruoyi
 */
@Service
public class UserDetailsServiceImpl implements UserDetailsService
{
    private static final Logger log = LoggerFactory.getLogger(UserDetailsServiceImpl.class);

    @Autowired
    private ISysUserService userService;
    @Autowired
    private SysTenantServiceImpl tenantService;
    @Autowired
    private ISysDeptService deptService;
    @Autowired
    private SysPermissionService permissionService;

    @Override
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException
    {
        SysUser user = userService.selectUserByUserName(username);
        if (StringUtils.isNull(user))
        {
            log.info("登录用户：{} 不存在.", username);
            throw new ServiceException("登录用户：" + username + " 不存在");
        }
        else if (UserStatus.DELETED.getCode().equals(user.getDeleteFlag()))
        {
            log.info("登录用户：{} 已被删除.", username);
            throw new ServiceException("对不起，您的账号：" + username + " 已被删除");
        }
        else if (UserStatus.DISABLE.getCode().equals(user.getStatus()))
        {
            log.info("登录用户：{} 已被停用.", username);
            throw new ServiceException("对不起，您的账号：" + username + " 已停用");
        }
        SysTenant tenant=tenantService.getById(user.getTenantId());
        if (ObjectUtil.isEmpty(tenant)
                || !tenant.getInUse().equals("0")
                || !DateUtil.date().before(tenant.getEndTime())
                || !tenant.getDeleteFlag().equals("0")
        ){
            log.info("用户所属租户：{} 异常.", tenant.getTenantName());
            throw new ServiceException("用户所属租户：" + tenant.getTenantName() + " 异常,无法登录！");
        }
        SysDept dept= deptService.getById(user.getDeptId());
        if (ObjectUtil.isEmpty(dept)
                || !dept.getStatus().equals("0")
                || !dept.getDeleteFlag().equals("0")
                || !DateUtil.date().before(DateUtil.parse(dept.getExpiryDate()))
        ){
            log.info("用户所属场馆：{} 异常.", dept.getDeptName());
            throw new ServiceException("用户所属场馆：" + dept.getDeptName() + " 异常,无法登录！");
        }
        return createLoginUser(user);
    }

    public UserDetails createLoginUser(SysUser user)
    {
        return new LoginUser(user.getUserId(), user.getDeptId(), user, permissionService.getMenuPermission(user));
    }


}
